#include <stdio.h>
#include <time.h>
#include "xts_common.h"

/*
**  Create the lock file.  Return the amount of time that has elapsed since
**  the last lock file was created, so that the caller may determine whether
**  to ask the user what to charge this time to.
*/
datetime *xtsu_lock_file_create ()
{
    FILE *fp;
    static datetime now;
    
    /*
    **  Attempt to read an existing lock file
    */
    fp = fopen ( XTS_LOCK_FILE, "r" );
    if ( fp == 0 )
    {
        
        xtsu_time_get ( &now );
        
        fp = fopen ( XTS_LOCK_FILE, "w" );
        if ( fp == 0 )
        {
            printf ( "xtsu_lock_file_create: could not create lock file\n" );
        }
        else
        {
            fwrite ( &now, sizeof ( datetime ), 1, fp );
            fclose ( fp );
        }
        return ( &now );
    }
    else
    {
        fread ( &now, sizeof ( datetime ), 1, fp );
        fclose ( fp );
        return ( &now );
    }
}

int xtsu_lock_file_delete ()
{
    return ( remove ( XTS_LOCK_FILE ) );
}
