#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#ifdef VMS
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <time.h>
#include <Xm/MessageB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Mrm/MrmAppl.h>
#include <X11/X.h>
#include <DXm/DECspecific.h>
#ifdef VMS
#include <DECw$Cursor.h>
#else
#include <X11/decwcursor.h>
#endif
#include "XTS.h"
#include "xtsu_database.h"

void xtsu_reflist_create ( Widget w, int *tag, unsigned long *reason )
{
    Arg arg[1];
    XmFontList fl;
    
    XtUnmanageChild ( XmSelectionBoxGetChild ( w, XmDIALOG_APPLY_BUTTON ) );
    XtSetArg ( arg[0], XmNtextFontList, &fl );
    XtGetValues ( w, arg, 1 );
    XtSetArg ( arg[0], XmNfontList, fl );
    XtSetValues ( XmSelectionBoxGetChild ( w, XmDIALOG_TEXT ), arg, 1 );
}

void xtsu_reflist_reload ( Widget w, int *tag, unsigned long *reason )
{
    Widget list = XmSelectionBoxGetChild ( w, XmDIALOG_LIST );
    
    /*
    **  Clear current list contents
    */
    XmListDeleteAllItems ( list );
    
    /*
    **  Build list from file
    */
    {
        FILE *input;
        XmString s;
        int i = 0;
        char *value;
        char *file;
        char buffer[512];
        
        file = getenv ( "XTS_REFLIST" );
        if ( file == NULL )
            file = xtsu_db_get_string ( "Xts.referenceListFile", "xts_reflist.dat" );
        
        input = fopen ( file, "r" );
        if ( input == NULL ) return;
        
        for (;;)
        {
            if ( feof ( input ) ) break;
            
            /* read entry */
            value = fgets ( buffer, 512, input );
            if ( value == NULL ) break;
            
            /* terminate it */
            value[strlen(value)-1] = '\0';

            /* create list item */
            s = XmStringCreateSimple ( value );
            XmListAddItem ( list, s, 0 );
            XmStringFree ( s );
            i++;
        }
        
        fclose ( input );
    }
}

void xtsu_reflist_ok
(
    Widget w, 
    int *tag, 
    XmSelectionBoxCallbackStruct *reason )
{
    char *value;
    
    /* grab a copy of the entered value */
    XmStringGetLtoR ( reason->value, XmSTRING_DEFAULT_CHARSET, &value );
    
    /* set the current entry editor value */
    {
        Widget id;
        
        if ( HashLookup ( "w_fd_entry", &id ) )
        {
            if ( XtIsManaged ( id ) )
            {
                HashLookup ( "w_tf_name", &id ) ;
                XmTextFieldSetString ( id, value );
            }
        }
    }
        
    XtFree ( value );
}
