#include "xtsu_time_unix.h"

void xtsu_time_get ( a )
    datetime *a;
{
    time ( a );
}

int xtsu_time_daynumber()
{
    datetime now;
    struct tm *tm;
        
    xtsu_time_get ( &now );
    tm = localtime ( &now );
    return ( tm->tm_wday );
}

void xtsu_time_add ( a, b, c )
    datetime *a, *b, *c ;
{
    *c = *a + *b;
}

void xtsu_time_subtract ( a, b, c )
    datetime *a, *b, *c ;
{
    *c = difftime ( *a, *b );
}


float xtsu_time_hours ( value )
    datetime *value;
{
    return ( *value / 3600.0 );
}

char *xtsu_time_to_text ( input )
    datetime *input;
{
    static char v[17];
    struct tm tm;
    datetime x;
        
    x = *input;
    tm.tm_sec  = x % 60;  x = x / 60;
    tm.tm_min  = x % 60;  x = x / 60;
    tm.tm_hour = x % 24;  x = x / 24;
    tm.tm_mday = x;
    
    sprintf ( v, "%4d %02d:%02d:%02d.%02d",
        tm.tm_mday,
        tm.tm_hour,
        tm.tm_min,
        tm.tm_sec,
        0 );

    return ( v );
}

char *xtsu_time_to_hhmmss ( input )
    datetime *input;
{
    static char v[17];
    struct tm tm;
    datetime x;
        
    x = *input;
    tm.tm_sec  = x % 60;  x = x / 60;
    tm.tm_min  = x % 60;  x = x / 60;
    tm.tm_hour = x % 24;  x = x / 24;
    tm.tm_mday = x;
    
    sprintf ( v, "%02d:%02d:%02d",
        tm.tm_mday * 24 + tm.tm_hour,
        tm.tm_min,
        tm.tm_sec );

    return ( v );
}

char *xtsu_time_to_hhmm ( input )
    datetime *input;
{
    static char v[17];
    struct tm tm;
    datetime x;
        
    x = *input;
    tm.tm_sec  = x % 60;  x = x / 60;
    tm.tm_min  = x % 60;  x = x / 60;
    tm.tm_hour = x % 24;  x = x / 24;
    tm.tm_mday = x;
    
    sprintf ( v, "%02d:%02d",
        tm.tm_mday * 24 + tm.tm_hour,
        tm.tm_min );

    return ( v );
}

char *xtsu_time_to_h_hh ( input )
    datetime *input;
{
    static char v[17];
    sprintf ( v, "%-5.2f", xtsu_time_hours ( input ) );
    return ( v );
}

datetime *xtsu_time_from_text ( input )
    char *input;
{
    struct tm tm;
    int hundredths;
    static datetime v;
    
    if ( ! strcmp ( "   0 00:00:00.00", input ) )
    {
        v = 0;
        return ( &v );
    }
    
    sscanf ( input, "%4d %2d:%2d:%2d.%2d",
        &tm.tm_mday,
        &tm.tm_hour,
        &tm.tm_min,
        &tm.tm_sec,
        &hundredths );

    v = ( ( tm.tm_mday * 24 + tm.tm_hour ) * 60 + tm.tm_min ) * 60 + tm.tm_sec;
    
    return ( &v );
}

datetime *xtsu_time_from_hhmm   ( char *input )
{
    struct tm tm;
    static datetime v;
    
    sscanf ( input, "%2d:%2d",
        &tm.tm_hour,
        &tm.tm_min
    );

    v = ( tm.tm_hour * 60 + tm.tm_min ) * 60;
    
    return ( &v );
}

datetime *xtsu_time_from_hhmmss ( char *input )
{
    struct tm tm;
    static datetime v;
    
    sscanf ( input, "%2d:%2d:%2d",
        &tm.tm_hour,
        &tm.tm_min,
        &tm.tm_sec
    );

    v = ( tm.tm_hour * 60 + tm.tm_min ) * 60 + tm.tm_sec;
    
    return ( &v );
}

datetime *xtsu_time_from_h_hh   ( char *input )
{
    float hours;
    static datetime v;
    
    sscanf ( input, "%f", &hours );
    v = ( hours * 3600.0 );
    
    return ( &v );
}
